/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.43 Revision 1.55
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.43 2007/03/13 09:48:02 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.55 2008/04/13 16:26:05 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
71 71
72# works in most cases 72# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 74
75# depend on headers for DVB-driver 75# depend on headers for DVB-driver
76RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1" 76DEPEND=">=media-tv/gentoo-vdr-scripts-0.3.8
77 || ( >=media-tv/gentoo-vdr-scripts-0.4.2 >=media-tv/vdrplugin-rebuild-0.2 )
78 >=app-admin/eselect-vdr-0.0.2
77DEPEND="media-tv/linuxtv-dvb-headers" 79 media-tv/linuxtv-dvb-headers"
78 80
79
80# this code is from linux-mod.eclass
81update_vdrplugindb() {
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
83
84 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then
85 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR}
86 touch ${VDRPLUGINDB_DIR}/vdrplugindb
87 fi
88 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
89 einfo "Adding plugin to vdrplugindb."
90 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
91 fi
92}
93
94remove_vdrplugindb() {
95 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
96
97 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
100 fi
101}
102 81
103# New method of storing plugindb 82# New method of storing plugindb
104# Called from src_install 83# Called from src_install
105# file maintained by normal portage-methods 84# file maintained by normal portage-methods
106create_plugindb_file() { 85create_plugindb_file() {
107 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 86 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
108 local DB_FILE=${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF} 87 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
109 insinto ${NEW_VDRPLUGINDB_DIR} 88 insinto "${NEW_VDRPLUGINDB_DIR}"
89
90# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
110 cat <<-EOT > ${D}/${DB_FILE} 91# cat <<-EOT > "${D}/${DB_FILE}"
111 VDRPLUGIN_DB=1 92# VDRPLUGIN_DB=1
112 CREATOR=ECLASS 93# CREATOR=ECLASS
113 EBUILD=${CATEGORY}/${PN} 94# EBUILD=${CATEGORY}/${PN}
114 EBUILD_V=${PVR} 95# EBUILD_V=${PVR}
115 EOT 96# EOT
97 {
98 echo "VDRPLUGIN_DB=1"
99 echo "CREATOR=ECLASS"
100 echo "EBUILD=${CATEGORY}/${PN}"
101 echo "EBUILD_V=${PVR}"
102 } > "${D}/${DB_FILE}"
116} 103}
117 104
118# Delete files created outside of vdr-plugin.eclass 105# Delete files created outside of vdr-plugin.eclass
119# vdrplugin-rebuild.ebuild converted plugindb and files are 106# vdrplugin-rebuild.ebuild converted plugindb and files are
120# not deleted by portage itself - should only be needed as 107# not deleted by portage itself - should only be needed as
121# long as not every system has switched over to 108# long as not every system has switched over to
122# vdrplugin-rebuild-0.2 109# vdrplugin-rebuild-0.2 / gentoo-vdr-scripts-0.4.2
123delete_orphan_plugindb_file() { 110delete_orphan_plugindb_file() {
124 #elog Testing for orphaned plugindb file 111 #elog Testing for orphaned plugindb file
125 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 112 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
126 local DB_FILE=${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF} 113 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
127 114
128 # file exists 115 # file exists
129 [[ -f ${DB_FILE} ]] || return 116 [[ -f ${DB_FILE} ]] || return
130 117
131 # will portage handle the file itself 118 # will portage handle the file itself
132 if grep -q CREATOR=ECLASS ${DB_FILE}; then 119 if grep -q CREATOR=ECLASS "${DB_FILE}"; then
133 #elog file owned by eclass - don't touch it 120 #elog file owned by eclass - don't touch it
134 return 121 return
135 fi 122 fi
136 123
137 elog "Removing orphaned plugindb-file." 124 elog "Removing orphaned plugindb-file."
138 elog "\t#rm ${DB_FILE}" 125 elog "\t#rm ${DB_FILE}"
139 rm ${DB_FILE} 126 rm "${DB_FILE}"
140} 127}
128
129
130create_header_checksum_file()
131{
132 # Danger: Not using $ROOT here, as compile will also not use it !!!
133 # If vdr in $ROOT and / differ, plugins will not run anyway
134
135 insinto "${VDR_CHECKSUM_DIR}"
136 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
137 newins "${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}"
138 else
139 if type -p md5sum >/dev/null 2>&1; then
140 cd "${S}"
141 (
142 cd "${VDR_INCLUDE_DIR}"
143 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
144 ) > header-md5-${PN}
145 doins header-md5-${PN}
146 fi
147 fi
148}
149
150fix_vdr_libsi_include()
151{
152 einfo "Fixing include of libsi-headers"
153 local f
154 for f; do
155 sed -i "${f}" \
156 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
157 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
158 done
159}
160
161vdr_patchmakefile() {
162 einfo "Patching Makefile"
163 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
164 cp Makefile "${WORKDIR}"/Makefile.before
165
166 ebegin " Setting Pathes"
167 sed -i Makefile \
168 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
169 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
170 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
171 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
172 -e "/^DVBDIR/d" \
173 -e 's:-I$(DVBDIR)/include::'
174 eend $?
175
176 # maybe needed for multiproto:
177 #sed -i Makefile \
178 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
179 # -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
180 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
181
182 if ! grep -q APIVERSION Makefile; then
183 ebegin " Converting to APIVERSION"
184 sed -i Makefile \
185 -e 's:^APIVERSION = :APIVERSION ?= :' \
186 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
187 -e '/VDRVERSION =/a\APIVERSION = $(shell sed -ne '"'"'/define APIVERSION/s/^.*"\\(.*\\)".*$$/\\1/p'"'"' $(VDRDIR)/config.h)'
188 eend $?
189 fi
190
191 # Correcting Compile-Flags
192 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
193 sed -i Makefile \
194 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
195 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
196
197 # Disabling file stripping, useful for debugging
198 sed -i Makefile \
199 -e '/@.*strip/d' \
200 -e '/strip \$(LIBDIR)\/\$@/d' \
201 -e '/@.*\$(STRIP)/d'
202
203 # Use a file instead of a variable as single-stepping via ebuild
204 # destroys environment.
205 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
206}
207
208vdr_add_local_patch() {
209 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
210 echo
211 einfo "Applying local patches"
212 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
213 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
214 done
215 fi
216}
217
218vdr_i18n() {
219 if [[ ${USE_GETTEXT} = 0 ]]; then
220 # Remove i18n Target if using older vdr
221 sed -i Makefile \
222 -e '/^all:/s/ i18n//'
223 elif [[ ${USE_GETTEXT} = 1 && ! -d po && ${NO_GETTEXT_HACK} != 1 ]]; then
224 einfo "Plugin is not yet changed for new translation system."
225 einfo "Auto converting translations to gettext"
226
227 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
228 if [[ ! -x ${i18n_tool} ]]; then
229 eerror "Missing ${i18n_tool}"
230 eerror "Please re-emerge vdr"
231 die "Missing ${i18n_tool}"
232 fi
233
234 # call i18n-to-gettext tool
235 # take all texts missing tr call into special file
236 "${i18n_tool}" 2>/dev/null \
237 |sed -e '/^"/!d' \
238 -e '/^""$/d' \
239 -e 's/\(.*\)/trNOOP(\1)/' \
240 > dummy-translations-trNOOP.c
241
242 # if there were untranslated texts just run it again
243 # now the missing calls are listed in
244 # dummy-translations-trNOOP.c
245 if [[ -s dummy-translations-trNOOP.c ]]; then
246 "${i18n_tool}" &>/dev/null
247 fi
248
249 # now use the modified Makefile
250 if [[ -f Makefile.new ]]; then
251 mv Makefile.new Makefile
252 else
253 ewarn "Conversion to gettext failed. Plugin needs fixing."
254 fi
255 fi
256}
257
258vdr-plugin_copy_source_tree() {
259 pushd . >/dev/null
260 cp -r "${S}" "${T}"/source-tree
261 cd "${T}"/source-tree
262 cp "${WORKDIR}"/Makefile.before Makefile
263 sed -i Makefile \
264 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
265 -e 's:^CXXFLAGS:#CXXFLAGS:' \
266 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
267 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
268 popd >/dev/null
269}
270
271vdr-plugin_install_source_tree() {
272 einfo "Installing sources"
273 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
274 insinto "${destdir}-${PV}"
275 doins -r "${T}"/source-tree/*
276
277 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
278}
279
280vdr-plugin_print_enable_command() {
281 elog
282 elog "To activate this vdr-plugin execute the following command:"
283 elog "\teselect vdr-plugin enable ${PN#vdr-}"
284 elog
285}
286
287
288## exported functions
141 289
142vdr-plugin_pkg_setup() { 290vdr-plugin_pkg_setup() {
143 # -fPIC is needed for shared objects on some platforms (amd64 and others) 291 # -fPIC is needed for shared objects on some platforms (amd64 and others)
144 append-flags -fPIC 292 append-flags -fPIC
145 293
154 # Pathes to includes 302 # Pathes to includes
155 VDR_INCLUDE_DIR="/usr/include/vdr" 303 VDR_INCLUDE_DIR="/usr/include/vdr"
156 DVB_INCLUDE_DIR="/usr/include" 304 DVB_INCLUDE_DIR="/usr/include"
157 305
158 306
307 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
308 LOCDIR="/usr/share/vdr/locale"
309 if has_version ">=media-video/vdr-1.5.7"; then
310 USE_GETTEXT=1
311 else
312 USE_GETTEXT=0
313 fi
314
159 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 315 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
160 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 316 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
161 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 317 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
162 318
163 einfo "Building ${PF} against vdr-${VDRVERSION}" 319 einfo "Compiling against"
164 einfo "APIVERSION: ${APIVERSION}" 320 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
165} 321}
166 322
167vdr-plugin_src_unpack() { 323vdr-plugin_src_unpack() {
168 if [[ -z ${VDR_INCLUDE_DIR} ]]; then 324 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
169 eerror "Wrong use of vdr-plugin.eclass." 325 eerror "Wrong use of vdr-plugin.eclass."
170 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 326 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
171 echo 327 echo
172 eerror "Please report this at bugs.gentoo.org." 328 eerror "Please report this at bugs.gentoo.org."
173 die "vdr-plugin_pkg_setup not called!" 329 die "vdr-plugin_pkg_setup not called!"
174 fi 330 fi
175 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile 331 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n
176 332
177 while [ "$1" ]; do 333 while [ "$1" ]; do
178 334
179 case "$1" in 335 case "$1" in
180 all_but_unpack) 336 all_but_unpack)
181 vdr-plugin_src_unpack add_local_patch patchmakefile 337 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
182 ;; 338 ;;
183 unpack) 339 unpack)
184 base_src_unpack 340 base_src_unpack
185 ;; 341 ;;
342 add_local_patch)
343 cd "${S}" || die "Could not change to plugin-source-directory!"
344 vdr_add_local_patch
345 ;;
186 patchmakefile) 346 patchmakefile)
187 if ! cd ${S}; then
188 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
189 ewarn "Perhaps you find one among these:"
190 cd "${WORKDIR}"
191 ewarn "$(/bin/ls -1 ${WORKDIR})"
192 die "Could not change to plugin-source-directory!" 347 cd "${S}" || die "Could not change to plugin-source-directory!"
193 fi 348 vdr_patchmakefile
194
195 einfo "Patching Makefile"
196 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
197 cp Makefile Makefile.orig
198
199 sed -i Makefile \
200 -e '1i\#Makefile was patched by vdr-plugin.eclass'
201
202 ebegin " Setting Pathes"
203 sed -i Makefile \
204 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
205 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
206 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
207 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
208 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
209 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
210 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
211 eend $?
212
213 ebegin " Converting to APIVERSION"
214 sed -i Makefile \
215 -e 's:^APIVERSION = :APIVERSION ?= :' \
216 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
217 -e '2i\APIVERSION = '"${APIVERSION}"
218 eend $?
219
220 ebegin " Correcting Compile-Flags"
221 sed -i Makefile \
222 -e 's:^CXXFLAGS:#CXXFLAGS:' \
223 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
224 eend $?
225
226 ebegin " Disabling file stripping"
227 sed -i Makefile \
228 -e '/@.*strip/d' \
229 -e '/strip \$(LIBDIR)\/\$@/d' \
230 -e '/^STRIP =/d' \
231 -e '/@.*\$(STRIP)/d'
232 eend $?
233
234 # Use a file instead of an variable as single-stepping via ebuild
235 # destroys environment.
236 touch ${WORKDIR}/.vdr-plugin_makefile_patched
237 ;; 349 ;;
238 add_local_patch) 350 i18n)
239 cd ${S} 351 cd "${S}" || die "Could not change to plugin-source-directory!"
240 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then 352 vdr_i18n
241 echo
242 einfo "Applying local patches"
243 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do
244 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
245 done
246 fi
247 ;; 353 ;;
248 esac 354 esac
249 355
250 shift 356 shift
251 done 357 done
252}
253
254vdr-plugin_copy_source_tree() {
255 pushd . >/dev/null
256 cp -r ${S} ${T}/source-tree
257 cd ${T}/source-tree
258 mv Makefile.orig Makefile
259 sed -i Makefile \
260 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
261 -e 's:^CXXFLAGS:#CXXFLAGS:' \
262 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
263 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
264 popd >/dev/null
265}
266
267vdr-plugin_install_source_tree() {
268 einfo "Installing sources"
269 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
270 insinto ${destdir}-${PV}
271 doins -r ${T}/source-tree/*
272
273 dosym ${VDRPLUGIN}-${PV} ${destdir}
274} 358}
275 359
276vdr-plugin_src_compile() { 360vdr-plugin_src_compile() {
277 [ -z "$1" ] && vdr-plugin_src_compile prepare compile 361 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
278 362
289 eerror "calling vdr-plugin_src_unpack to patch the Makefile." 373 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
290 echo 374 echo
291 eerror "Please report this at bugs.gentoo.org." 375 eerror "Please report this at bugs.gentoo.org."
292 die "vdr-plugin_src_unpack not called!" 376 die "vdr-plugin_src_unpack not called!"
293 fi 377 fi
294 cd ${S} 378 cd "${S}"
295 379
296 emake ${BUILD_PARAMS} ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed" 380 emake ${BUILD_PARAMS} \
381 ${VDRPLUGIN_MAKE_TARGET:-all} \
382 LOCALEDIR="${TMP_LOCALE_DIR}" \
383 || die "emake failed"
297 ;; 384 ;;
298 esac 385 esac
299 386
300 shift 387 shift
301 done 388 done
302} 389}
303 390
304vdr-plugin_src_install() { 391vdr-plugin_src_install() {
305 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree 392 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
306 cd ${S} 393 cd "${WORKDIR}"
307 394
308 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then 395 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
309 local mname=${P}-Makefile 396 local mname="${P}-Makefile"
310 cp Makefile ${mname}.patched 397 cp "${S}"/Makefile "${mname}.patched"
311 cp Makefile.orig ${mname}.before 398 cp Makefile.before "${mname}.before"
312 399
313 diff -u ${mname}.before ${mname}.patched > ${mname}.diff 400 diff -u "${mname}.before" "${mname}.patched" > "${mname}.diff"
314 401
315 insinto "/usr/share/vdr/maintainer-data/makefile-changes" 402 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
316 doins ${mname}.diff 403 doins "${mname}.diff"
317 404
318 insinto "/usr/share/vdr/maintainer-data/makefile-before" 405 insinto "/usr/share/vdr/maintainer-data/makefile-before"
319 doins ${mname}.before 406 doins "${mname}.before"
320 407
321 insinto "/usr/share/vdr/maintainer-data/makefile-patched" 408 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
322 doins ${mname}.patched 409 doins "${mname}.patched"
323 410
324 fi 411 fi
325 412
413 cd "${S}"
326 insinto "${VDR_PLUGIN_DIR}" 414 insinto "${VDR_PLUGIN_DIR}"
327 doins libvdr-*.so.* 415 doins libvdr-*.so.*
416
417 if [[ ${USE_GETTEXT} = 1 && -d ${TMP_LOCALE_DIR} ]]; then
418 einfo "Installing locales"
419 cd "${TMP_LOCALE_DIR}"
420 insinto "${LOCDIR}"
421 doins -r *
422 fi
423
424 cd "${S}"
328 local docfile 425 local docfile
329 for docfile in README* HISTORY CHANGELOG; do 426 for docfile in README* HISTORY CHANGELOG; do
330 [[ -f ${docfile} ]] && dodoc ${docfile} 427 [[ -f ${docfile} ]] && dodoc ${docfile}
331 done 428 done
332 429
333 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it 430 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it
334 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd 431 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd
335 432
336 if [[ -n ${VDR_CONFD_FILE} ]]; then 433 if [[ -n ${VDR_CONFD_FILE} ]]; then
337 insinto /etc/conf.d
338 newins "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN} 434 newconfd "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN}
339 fi 435 fi
340 436
341 437
342 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it 438 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it
343 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh 439 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh
345 if [[ -n ${VDR_RCADDON_FILE} ]]; then 441 if [[ -n ${VDR_RCADDON_FILE} ]]; then
346 insinto "${VDR_RC_DIR}" 442 insinto "${VDR_RC_DIR}"
347 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 443 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
348 fi 444 fi
349 445
350 446 create_header_checksum_file
351
352 # Danger: Not using $ROOT here, as compile will also not use it !!!
353 # If vdr in $ROOT and / differ, plugins will not run anyway
354
355 insinto ${VDR_CHECKSUM_DIR}
356 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
357 newins ${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}
358 else
359 if type -p md5sum >/dev/null 2>&1; then
360 cd ${S}
361 (
362 cd ${VDR_INCLUDE_DIR}
363 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
364 ) > header-md5-${PN}
365 doins header-md5-${PN}
366 fi
367 fi
368
369 create_plugindb_file 447 create_plugindb_file
370} 448}
371 449
372vdr-plugin_pkg_postinst() { 450vdr-plugin_pkg_postinst() {
373 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then 451 vdr-plugin_print_enable_command
374 update_vdrplugindb 452
375 fi
376 elog
377 elog "The vdr plugin ${VDRPLUGIN} has now been installed."
378 elog "To activate execute the following command:"
379 elog
380 elog " emerge --config ${PN}"
381 elog
382 if [[ -n "${VDR_CONFD_FILE}" ]]; then 453 if [[ -n "${VDR_CONFD_FILE}" ]]; then
383 elog "And have a look at the config-file" 454 elog "Please have a look at the config-file"
384 elog "/etc/conf.d/vdr.${VDRPLUGIN}" 455 elog "\t/etc/conf.d/vdr.${VDRPLUGIN}"
385 elog 456 elog
386 fi 457 fi
387} 458}
388 459
389vdr-plugin_pkg_postrm() { 460vdr-plugin_pkg_postrm() {
390 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
391 remove_vdrplugindb
392 fi
393 delete_orphan_plugindb_file 461 delete_orphan_plugindb_file
394} 462}
395 463
396vdr-plugin_pkg_config_final() {
397 diff ${conf_orig} ${conf}
398 rm ${conf_orig}
399}
400
401vdr-plugin_pkg_config_old() {
402 elog "Using interface of gentoo-vdr-scripts-0.3.6 and older"
403 if [[ -z "${INSTALLPLUGIN}" ]]; then
404 INSTALLPLUGIN="${VDRPLUGIN}"
405 fi
406 # First test if plugin is already inside PLUGINS
407 local conf=/etc/conf.d/vdr
408 conf_orig=${conf}.before_emerge_config
409 cp ${conf} ${conf_orig}
410
411 elog "Reading ${conf}"
412 if ! grep -q "^PLUGINS=" ${conf}; then
413 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
414 if [[ -n "${LINE}" ]]; then
415 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
416 else
417 echo 'PLUGINS=""' >> ${conf}
418 fi
419 unset LINE
420 fi
421
422 unset PLUGINS
423 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
424
425 active=0
426 for p in ${PLUGINS}; do
427 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
428 active=1
429 break;
430 fi
431 done
432
433 if [[ "${active}" == "1" ]]; then
434 elog "${INSTALLPLUGIN} already activated"
435 echo
436 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
437 if [[ "${answer}" != "yes" ]]; then
438 elog "aborted"
439 return
440 fi
441 elog "Removing ${INSTALLPLUGIN} from active plugins."
442 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
443 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
444 -e ${LINE}'s/ \( \)*/ /g' \
445 -e ${LINE}'s/ "/"/g' \
446 -e ${LINE}'s/" /"/g'
447
448 vdr-plugin_pkg_config_final
449 return
450 fi
451
452
453 elog "Adding ${INSTALLPLUGIN} to active plugins."
454 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
455 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
456 -e ${LINE}'s/ \( \)*/ /g' \
457 -e ${LINE}'s/ "/"/g' \
458 -e ${LINE}'s/" /"/g'
459
460 vdr-plugin_pkg_config_final
461}
462
463vdr-plugin_pkg_config_new() {
464 elog "Using interface introduced with gentoo-vdr-scripts-0.3.7"
465 if [[ -z "${INSTALLPLUGIN}" ]]; then
466 INSTALLPLUGIN="${VDRPLUGIN}"
467 fi
468
469 active=0
470 # First test if plugin is already inside PLUGINS
471 local conf=/etc/conf.d/vdr.plugins
472 exec 3<${conf}
473 while read -u 3 line; do
474 [[ ${line} == "" ]] && continue
475 [[ ${line:0:1} == "#" ]] && continue
476 set -- ${line}
477 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
478 done
479 exec 3<&-
480
481 if [[ $active == 0 ]]; then
482 elog "Adding ${INSTALLPLUGIN} to active plugins."
483
484 # The pure edit process.
485 echo "${INSTALLPLUGIN}" >> "${conf}"
486 else
487 elog "${INSTALLPLUGIN} already activated"
488 echo
489 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
490 if [[ "${answer}" != "yes" ]]; then
491 elog "aborted"
492 return
493 fi
494 elog "Removing ${INSTALLPLUGIN} from active plugins."
495
496 # The pure edit process
497 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
498 fi
499}
500
501vdr-plugin_pkg_config() { 464vdr-plugin_pkg_config() {
502 if has_version ">media-tv/gentoo-vdr-scripts-0.3.6"; then 465 ewarn "emerge --config ${PN} is no longer supported"
503 vdr-plugin_pkg_config_new 466 vdr-plugin_print_enable_command
504 else
505 vdr-plugin_pkg_config_old
506 fi
507}
508
509fix_vdr_libsi_include()
510{
511 einfo "Fixing include of libsi-headers"
512 local f
513 for f; do
514 sed -i "${f}" \
515 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
516 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
517 done
518} 467}
519 468
520EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 469EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config

Legend:
Removed from v.1.43  
changed lines
  Added in v.1.55

  ViewVC Help
Powered by ViewVC 1.1.20